
typedef struct {
  int n, k; int autointercept;
  double sse, rsq, adjrsq;     /* derived, not updated in include */
  double sigmasq;

  double      wghtn;    /* Individualized values */
  double        *d;     /* the diagonal scaling matrix */
  double        *thetabar;      /* where D^.5 thetabar is the vector of */
  double        *rbar;  /* the superdiagonal */
  double *Theta;
  int rbarsize;

  void print( ) const {
    fputc('\n', stderr);
    fprintf(stderr, "n=%d, k=%d, ai=%d\n", n, k, autointercept);
    fprintf(stderr, "sse=%f, rsq=%f, adjrsq=%f;  sigma=%f\n", sse, rsq, adjrsq, sigmasq);
    fprintf(stderr, "wghtn=%f [rbarsize=%d]\n", wghtn, rbarsize);

    for (int i=0; i<=k; ++i) fprintf(stderr, "d%d=%f ", i, d[i]);
    fputc('\n', stderr);
    for (int i=0; i<=k; ++i) fprintf(stderr, "tb%d=%f ", i, thetabar[i]);
    fputc('\n', stderr);
    for (int i=0; i<rbarsize; ++i) fprintf(stderr, "rb%d=%f ", i, rbar[i]);
    fputc('\n', stderr);
    fputc('\n', stderr);
  }

  void rescale(const double downscale) {
    sse*= downscale;
    wghtn*= downscale;
    for (int i=0; i<=k; ++i) d[i]*= downscale;
  }

} FREGR;                /* elements of R~ stored sequentially */



FREGR *fregr_new(int numind);
FREGR *fregr_clear(FREGR *gnew);
FREGR *fregr_end(FREGR *in);
void fregr_include( FREGR *in, double weight, double yelement, const double *xrow);
double *fregr_regress(FREGR *in);


